﻿Public Class CalcForm
    'متغير لحفظ الأداة 
    Dim vCode As Char = "="
    'متغير للتذكير بإفراغ مربع النص
    Dim vClear As Boolean = False
    'متغير لحفظ الرقم الأول لأكثر من عملية
    Dim vNumber As Double
    'متغير لحفظ رقم في الذاكرة
    Dim vMem As Double = 0

    'إجرائية ضغط أزرار الأرقام
    Private Sub OneButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OneButton.Click, _
    TwoButton.Click, ThreeButton.Click, FourButton.Click, FiveButton.Click, SixButton.Click, SevenButton.Click, EightButton.Click, _
    NineButton.Click, ZeroButton.Click
        'تنبيه الحذف
        If vClear Then
            Me.ScreenTextBox.Text = "0"
            vClear = False
        End If

        If Me.ScreenTextBox.Text = "0" Then
            'في حال عدم وجود أي رقم في المربع النصي
            ScreenTextBox.Text = sender.text
        Else
            ScreenTextBox.Text = ScreenTextBox.Text + sender.text
        End If

    End Sub

    Private Sub DotButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DotButton.Click
        'إجرائية زر النقطة
        If vClear Then
            'تنبيه الحذف
            Me.ScreenTextBox.Text = "0"
            vClear = False
        End If
        If Val(Me.ScreenTextBox.Text) = 0 Then
            ScreenTextBox.Text = "0."
        Else
            'لعدم تكرير الفاصلة
            If InStr(Me.ScreenTextBox.Text, ".") = 0 Then
                ScreenTextBox.Text = ScreenTextBox.Text + "."
            End If
            End If
    End Sub

    'إجرائية أزرار الأدوات
    Private Sub PlusButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PlusButton.Click, _
    DividButton.Click, MinusButton.Click, MultiplicatButton.Click, EqualButton.Click
        'حالة عدم وجود عملية سابقة
        If vCode = "=" Then
        Else
            'حالات وجود عمليات سابقة
            Select Case vCode
                Case "+"
                    Me.ScreenTextBox.Text = vNumber + Val(Me.ScreenTextBox.Text)
                Case "-"
                    Me.ScreenTextBox.Text = vNumber - Val(Me.ScreenTextBox.Text)
                Case "*"
                    Me.ScreenTextBox.Text = vNumber * Val(Me.ScreenTextBox.Text)
                Case "/"
                    'للتنبيه على عدم إمكانية التقسيم على 0
                    If Val(Me.ScreenTextBox.Text) = 0 Then
                        Me.ScreenTextBox.Text = "يتعذر القسمة على صفر"
                    Else
                        Me.ScreenTextBox.Text = vNumber / Val(Me.ScreenTextBox.Text)
                    End If
            End Select

        End If
        'حفظ الرقم الأول
        vNumber = Val(Me.ScreenTextBox.Text)
        'تشغيل المنبه
        vClear = True
        'حفظ الأداة
        vCode = sender.text
    End Sub

    Private Sub MSButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MSButton.Click
        'إجرائية ضغط زر حفظ الذاكرة
        vMem = Val(Me.ScreenTextBox.Text)
        vClear = True
    End Sub

    Private Sub MRButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MRButton.Click
        'إجرائية ضغط زر استرجاع الذاكرة
        ScreenTextBox.Text = vMem.ToString
        vClear = True
    End Sub

    Private Sub MCButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MCButton.Click
        'إجرائية ضغط زر تفريغ الذاكرة
        vMem = 0
        vClear = True
    End Sub

    Private Sub MPlusButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MPlusButton.Click
        'جمع الرقم الموجود في المربع النصي مع رقم الذاكرة وعرض الناتج
        vMem += Val(Me.ScreenTextBox.Text)
        vClear = True
    End Sub

    Private Sub MMinusButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MMinusButton.Click
        'طرح الرقم الموجود في المربع النصي من رقم الذاكرة وعرض الناتج
        vMem -= Val(Me.ScreenTextBox.Text)
        vClear = True
    End Sub

    'إجرائية ضغط زر تفريغ كل من المربع النصي ومتغير الذاكرة
    Private Sub ClearButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearButton.Click
        ScreenTextBox.Text = "0"
        vNumber = 0
    End Sub

    'إجرائية ضغط زر تغيير الإشارة
    Private Sub NegativeButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NegativeButton.Click
        Me.ScreenTextBox.Text = -Val(Me.ScreenTextBox.Text)
    End Sub
    'إجرائية ضغط زر الجذر
    Private Sub SqrButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SqrButton.Click
        'التأكد من ان العدد أكبر من الصفر
        If Val(Me.ScreenTextBox.Text) < 0 Then
            ScreenTextBox.Text = "لا يمكن جذر العدد السالب"
            vClear = True
        Else

            Me.ScreenTextBox.Text = Math.Sqrt(Val(Me.ScreenTextBox.Text))
            vClear = True
        End If
    End Sub

    'إجرائية ضغط زر الحذف
    Private Sub DeleteButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeleteButton.Click
        'حذف رقم واحد من اليسار
        Me.ScreenTextBox.Text = Microsoft.VisualBasic.Left(Me.ScreenTextBox.Text, Me.ScreenTextBox.Text.Length - 1)
        'للتوقف عن الحذف عند انتهاء الأرقام
        If Me.ScreenTextBox.Text.Length = 0 Then
            ScreenTextBox.Text = "0"
        End If
    End Sub

    'إجرائية ضغط زر النسبة المئوية
    Private Sub PercentButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PercentButton.Click
        vNumber = Val(Me.ScreenTextBox.Text)
        Me.ScreenTextBox.Text = Val(Me.ScreenTextBox.Text) * vNumber / 100
        vClear = True
    End Sub

    'إجرائية ضغط زر نسبة الرقم غلى واحد
    Private Sub BreakButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BreakButton.Click
        Me.ScreenTextBox.Text = 1 / Val(Me.ScreenTextBox.Text)
        vClear = True
    End Sub

    Private Sub InfoButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InfoButton.Click
        MessageBox.Show("برمجة brkt_a خاص mexat.com", "نبذة", MessageBoxButtons.OK, MessageBoxIcon.Hand, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign)

    End Sub
End Class
